'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _ = require('lodash');
var moment = _interopDefault(require('moment'));

/**
 * Afrikaans
 */
var en_us = {
    locale: 'en-US',
    messages: {
        after: 'Must be after ${date}',
        alpha: 'Can only use letters',
        alphanumeric: 'Must be alphanumeric',
        array: 'Must be an array',
        ascii: 'Must be ASCII',
        base64: 'Must be valid Base64',
        before: 'Must be before ${date}',
        between: 'Must be between ${min} and ${max}',
        between_inclusive: 'Must be between ${min} and ${max}, inclusive',
        boolean: 'Must be true or false',
        creditcard: 'Must be a valid credit card number',
        date: 'Must be a valid date',
        dateformat: 'Must use "${format}" format',
        defined: 'Required',
        email: 'Must be a valid email address',
        empty: 'Must be empty',
        equals: 'Must be equal to ${other}',
        gt: 'Must be greater than ${min}',
        gte: 'Must be greater than or equal to ${min}',
        integer: 'Must be an integer',
        ip: 'Must be a valid IP address',
        isblank: 'May not be blank',
        isnil: 'Required',
        isnull: 'Required',
        iso8601: 'Must be a valid ISO8601 date',
        json: 'Must be a valid JSON',
        length: 'Must have a length of at least ${min}',
        length_between: 'Must have a length between ${min} and ${max}',
        lt: 'Must be less than ${max}',
        lte: 'Must be less than or equal to ${max}',
        match: 'Must match "${pattern}"',
        negative: 'Must be a negative number',
        not: 'Can not be ${value}',
        number: 'Must be a number',
        numeric: 'Must be numeric',
        object: 'Must be an object',
        positive: 'Must be a positive number',
        required: 'Required',
        same: 'Must have the same value as "${other}"',
        string: 'Must be a string',
        url: 'Must be a valid URL',
        uuid: 'Must be a valid UUID'
    }

    /**
     * Portuguese - Brazil
     */
};

function unwrapExports (x) {
	return x && x.__esModule ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var assertString_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = assertString;
function assertString(input) {
  var isString$$1 = typeof input === 'string' || input instanceof String;

  if (!isString$$1) {
    throw new TypeError('This library (validator.js) validates strings only');
  }
}
module.exports = exports['default'];
});

unwrapExports(assertString_1);

var alpha_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var alpha = exports.alpha = {
  'en-US': /^[A-Z]+$/i,
  'cs-CZ': /^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,
  'da-DK': /^[A-ZÆØÅ]+$/i,
  'de-DE': /^[A-ZÄÖÜß]+$/i,
  'es-ES': /^[A-ZÁÉÍÑÓÚÜ]+$/i,
  'fr-FR': /^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,
  'it-IT': /^[A-ZÀÉÈÌÎÓÒÙ]+$/i,
  'nb-NO': /^[A-ZÆØÅ]+$/i,
  'nl-NL': /^[A-ZÁÉËÏÓÖÜÚ]+$/i,
  'nn-NO': /^[A-ZÆØÅ]+$/i,
  'hu-HU': /^[A-ZÁÉÍÓÖŐÚÜŰ]+$/i,
  'pl-PL': /^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,
  'pt-PT': /^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,
  'ru-RU': /^[А-ЯЁ]+$/i,
  'sr-RS@latin': /^[A-ZČĆŽŠĐ]+$/i,
  'sr-RS': /^[А-ЯЂЈЉЊЋЏ]+$/i,
  'sv-SE': /^[A-ZÅÄÖ]+$/i,
  'tr-TR': /^[A-ZÇĞİıÖŞÜ]+$/i,
  'uk-UA': /^[А-ЩЬЮЯЄIЇҐ]+$/i,
  ar: /^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/
};

var alphanumeric = exports.alphanumeric = {
  'en-US': /^[0-9A-Z]+$/i,
  'cs-CZ': /^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,
  'da-DK': /^[0-9A-ZÆØÅ]+$/i,
  'de-DE': /^[0-9A-ZÄÖÜß]+$/i,
  'es-ES': /^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,
  'fr-FR': /^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,
  'it-IT': /^[0-9A-ZÀÉÈÌÎÓÒÙ]+$/i,
  'hu-HU': /^[0-9A-ZÁÉÍÓÖŐÚÜŰ]+$/i,
  'nb-NO': /^[0-9A-ZÆØÅ]+$/i,
  'nl-NL': /^[0-9A-ZÁÉËÏÓÖÜÚ]+$/i,
  'nn-NO': /^[0-9A-ZÆØÅ]+$/i,
  'pl-PL': /^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,
  'pt-PT': /^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,
  'ru-RU': /^[0-9А-ЯЁ]+$/i,
  'sr-RS@latin': /^[0-9A-ZČĆŽŠĐ]+$/i,
  'sr-RS': /^[0-9А-ЯЂЈЉЊЋЏ]+$/i,
  'sv-SE': /^[0-9A-ZÅÄÖ]+$/i,
  'tr-TR': /^[0-9A-ZÇĞİıÖŞÜ]+$/i,
  'uk-UA': /^[0-9А-ЩЬЮЯЄIЇҐ]+$/i,
  ar: /^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/
};

var englishLocales = exports.englishLocales = ['AU', 'GB', 'HK', 'IN', 'NZ', 'ZA', 'ZM'];

for (var locale, i = 0; i < englishLocales.length; i++) {
  locale = 'en-' + englishLocales[i];
  alpha[locale] = alpha['en-US'];
  alphanumeric[locale] = alphanumeric['en-US'];
}

alpha['pt-BR'] = alpha['pt-PT'];
alphanumeric['pt-BR'] = alphanumeric['pt-PT'];

// Source: http://www.localeplanet.com/java/
var arabicLocales = exports.arabicLocales = ['AE', 'BH', 'DZ', 'EG', 'IQ', 'JO', 'KW', 'LB', 'LY', 'MA', 'QM', 'QA', 'SA', 'SD', 'SY', 'TN', 'YE'];

for (var _locale, _i = 0; _i < arabicLocales.length; _i++) {
  _locale = 'ar-' + arabicLocales[_i];
  alpha[_locale] = alpha.ar;
  alphanumeric[_locale] = alphanumeric.ar;
}
});

unwrapExports(alpha_1);

var isAlpha_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isAlpha;



var _assertString2 = _interopRequireDefault(assertString_1);



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isAlpha(str) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'en-US';

  (0, _assertString2.default)(str);
  if (locale in alpha_1.alpha) {
    return alpha_1.alpha[locale].test(str);
  }
  throw new Error('Invalid locale \'' + locale + '\'');
}
module.exports = exports['default'];
});

var isAlpha = unwrapExports(isAlpha_1);

var isAlphanumeric_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isAlphanumeric;



var _assertString2 = _interopRequireDefault(assertString_1);



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isAlphanumeric(str) {
  var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'en-US';

  (0, _assertString2.default)(str);
  if (locale in alpha_1.alphanumeric) {
    return alpha_1.alphanumeric[locale].test(str);
  }
  throw new Error('Invalid locale \'' + locale + '\'');
}
module.exports = exports['default'];
});

var isAlphanumeric = unwrapExports(isAlphanumeric_1);

var isBase64_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isBase64;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var notBase64 = /[^A-Z0-9+\/=]/i;

function isBase64(str) {
  (0, _assertString2.default)(str);
  var len = str.length;
  if (!len || len % 4 !== 0 || notBase64.test(str)) {
    return false;
  }
  var firstPaddingChar = str.indexOf('=');
  return firstPaddingChar === -1 || firstPaddingChar === len - 1 || firstPaddingChar === len - 2 && str[len - 1] === '=';
}
module.exports = exports['default'];
});

var isBase64 = unwrapExports(isBase64_1);

var isCreditCard_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isCreditCard;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable max-len */
var creditCard = /^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11}|62[0-9]{14})$/;
/* eslint-enable max-len */

function isCreditCard(str) {
  (0, _assertString2.default)(str);
  var sanitized = str.replace(/[- ]+/g, '');
  if (!creditCard.test(sanitized)) {
    return false;
  }
  var sum = 0;
  var digit = void 0;
  var tmpNum = void 0;
  var shouldDouble = void 0;
  for (var i = sanitized.length - 1; i >= 0; i--) {
    digit = sanitized.substring(i, i + 1);
    tmpNum = parseInt(digit, 10);
    if (shouldDouble) {
      tmpNum *= 2;
      if (tmpNum >= 10) {
        sum += tmpNum % 10 + 1;
      } else {
        sum += tmpNum;
      }
    } else {
      sum += tmpNum;
    }
    shouldDouble = !shouldDouble;
  }
  return !!(sum % 10 === 0 ? sanitized : false);
}
module.exports = exports['default'];
});

var isCreditCard = unwrapExports(isCreditCard_1);

var merge_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = merge;
function merge() {
  var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var defaults = arguments[1];

  for (var key in defaults) {
    if (typeof obj[key] === 'undefined') {
      obj[key] = defaults[key];
    }
  }
  return obj;
}
module.exports = exports['default'];
});

unwrapExports(merge_1);

var isByteLength_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = isByteLength;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable prefer-rest-params */
function isByteLength(str, options) {
  (0, _assertString2.default)(str);
  var min = void 0;
  var max = void 0;
  if ((typeof options === 'undefined' ? 'undefined' : _typeof(options)) === 'object') {
    min = options.min || 0;
    max = options.max;
  } else {
    // backwards compatibility: isByteLength(str, min [, max])
    min = arguments[1];
    max = arguments[2];
  }
  var len = encodeURI(str).split(/%..|./).length - 1;
  return len >= min && (typeof max === 'undefined' || len <= max);
}
module.exports = exports['default'];
});

unwrapExports(isByteLength_1);

var isFQDN = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isFDQN;



var _assertString2 = _interopRequireDefault(assertString_1);



var _merge2 = _interopRequireDefault(merge_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var default_fqdn_options = {
  require_tld: true,
  allow_underscores: false,
  allow_trailing_dot: false
};

function isFDQN(str, options) {
  (0, _assertString2.default)(str);
  options = (0, _merge2.default)(options, default_fqdn_options);

  /* Remove the optional trailing dot before checking validity */
  if (options.allow_trailing_dot && str[str.length - 1] === '.') {
    str = str.substring(0, str.length - 1);
  }
  var parts = str.split('.');
  if (options.require_tld) {
    var tld = parts.pop();
    if (!parts.length || !/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(tld)) {
      return false;
    }
    // disallow spaces
    if (/[\s\u2002-\u200B\u202F\u205F\u3000\uFEFF\uDB40\uDC20]/.test(tld)) {
      return false;
    }
  }
  for (var part, i = 0; i < parts.length; i++) {
    part = parts[i];
    if (options.allow_underscores) {
      part = part.replace(/_/g, '');
    }
    if (!/^[a-z\u00a1-\uffff0-9-]+$/i.test(part)) {
      return false;
    }
    // disallow full-width chars
    if (/[\uff01-\uff5e]/.test(part)) {
      return false;
    }
    if (part[0] === '-' || part[part.length - 1] === '-') {
      return false;
    }
  }
  return true;
}
module.exports = exports['default'];
});

unwrapExports(isFQDN);

var isEmail_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isEmail;



var _assertString2 = _interopRequireDefault(assertString_1);



var _merge2 = _interopRequireDefault(merge_1);



var _isByteLength2 = _interopRequireDefault(isByteLength_1);



var _isFQDN2 = _interopRequireDefault(isFQDN);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var default_email_options = {
  allow_display_name: false,
  require_display_name: false,
  allow_utf8_local_part: true,
  require_tld: true
};

/* eslint-disable max-len */
/* eslint-disable no-control-regex */
var displayName = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\,\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i;
var emailUserPart = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i;
var quotedEmailUser = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i;
var emailUserUtf8Part = /^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i;
var quotedEmailUserUtf8 = /^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i;
/* eslint-enable max-len */
/* eslint-enable no-control-regex */

function isEmail(str, options) {
  (0, _assertString2.default)(str);
  options = (0, _merge2.default)(options, default_email_options);

  if (options.require_display_name || options.allow_display_name) {
    var display_email = str.match(displayName);
    if (display_email) {
      str = display_email[1];
    } else if (options.require_display_name) {
      return false;
    }
  }

  var parts = str.split('@');
  var domain = parts.pop();
  var user = parts.join('@');

  var lower_domain = domain.toLowerCase();
  if (lower_domain === 'gmail.com' || lower_domain === 'googlemail.com') {
    user = user.replace(/\./g, '').toLowerCase();
  }

  if (!(0, _isByteLength2.default)(user, { max: 64 }) || !(0, _isByteLength2.default)(domain, { max: 254 })) {
    return false;
  }

  if (!(0, _isFQDN2.default)(domain, { require_tld: options.require_tld })) {
    return false;
  }

  if (user[0] === '"') {
    user = user.slice(1, user.length - 1);
    return options.allow_utf8_local_part ? quotedEmailUserUtf8.test(user) : quotedEmailUser.test(user);
  }

  var pattern = options.allow_utf8_local_part ? emailUserUtf8Part : emailUserPart;

  var user_parts = user.split('.');
  for (var i = 0; i < user_parts.length; i++) {
    if (!pattern.test(user_parts[i])) {
      return false;
    }
  }

  return true;
}
module.exports = exports['default'];
});

var isEmail = unwrapExports(isEmail_1);

var isIP_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isIP;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ipv4Maybe = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
var ipv6Block = /^[0-9A-F]{1,4}$/i;

function isIP(str) {
  var version = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  (0, _assertString2.default)(str);
  version = String(version);
  if (!version) {
    return isIP(str, 4) || isIP(str, 6);
  } else if (version === '4') {
    if (!ipv4Maybe.test(str)) {
      return false;
    }
    var parts = str.split('.').sort(function (a, b) {
      return a - b;
    });
    return parts[3] <= 255;
  } else if (version === '6') {
    var blocks = str.split(':');
    var foundOmissionBlock = false; // marker to indicate ::

    // At least some OS accept the last 32 bits of an IPv6 address
    // (i.e. 2 of the blocks) in IPv4 notation, and RFC 3493 says
    // that '::ffff:a.b.c.d' is valid for IPv4-mapped IPv6 addresses,
    // and '::a.b.c.d' is deprecated, but also valid.
    var foundIPv4TransitionBlock = isIP(blocks[blocks.length - 1], 4);
    var expectedNumberOfBlocks = foundIPv4TransitionBlock ? 7 : 8;

    if (blocks.length > expectedNumberOfBlocks) {
      return false;
    }
    // initial or final ::
    if (str === '::') {
      return true;
    } else if (str.substr(0, 2) === '::') {
      blocks.shift();
      blocks.shift();
      foundOmissionBlock = true;
    } else if (str.substr(str.length - 2) === '::') {
      blocks.pop();
      blocks.pop();
      foundOmissionBlock = true;
    }

    for (var i = 0; i < blocks.length; ++i) {
      // test for a :: which can not be at the string start/end
      // since those cases have been handled above
      if (blocks[i] === '' && i > 0 && i < blocks.length - 1) {
        if (foundOmissionBlock) {
          return false; // multiple :: in address
        }
        foundOmissionBlock = true;
      } else if (foundIPv4TransitionBlock && i === blocks.length - 1) {
        // it has been checked before that the last
        // block is a valid IPv4 address
      } else if (!ipv6Block.test(blocks[i])) {
        return false;
      }
    }
    if (foundOmissionBlock) {
      return blocks.length >= 1;
    }
    return blocks.length === expectedNumberOfBlocks;
  }
  return false;
}
module.exports = exports['default'];
});

var isIP = unwrapExports(isIP_1);

var isISO8601_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isISO8601;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable max-len */
// from http://goo.gl/0ejHHW
var iso8601 = /^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
/* eslint-enable max-len */

function isISO8601(str) {
  (0, _assertString2.default)(str);
  return iso8601.test(str);
}
module.exports = exports['default'];
});

var isISO8601 = unwrapExports(isISO8601_1);

var isJSON_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = isJSON;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isJSON(str) {
  (0, _assertString2.default)(str);
  try {
    var obj = JSON.parse(str);
    return !!obj && (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object';
  } catch (e) {/* ignore */}
  return false;
}
module.exports = exports['default'];
});

var isJSON = unwrapExports(isJSON_1);

var isURL_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isURL;



var _assertString2 = _interopRequireDefault(assertString_1);



var _isFQDN2 = _interopRequireDefault(isFQDN);



var _isIP2 = _interopRequireDefault(isIP_1);



var _merge2 = _interopRequireDefault(merge_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var default_url_options = {
  protocols: ['http', 'https', 'ftp'],
  require_tld: true,
  require_protocol: false,
  require_host: true,
  require_valid_protocol: true,
  allow_underscores: false,
  allow_trailing_dot: false,
  allow_protocol_relative_urls: false
};

var wrapped_ipv6 = /^\[([^\]]+)\](?::([0-9]+))?$/;

function isRegExp(obj) {
  return Object.prototype.toString.call(obj) === '[object RegExp]';
}

function checkHost(host, matches) {
  for (var i = 0; i < matches.length; i++) {
    var match = matches[i];
    if (host === match || isRegExp(match) && match.test(host)) {
      return true;
    }
  }
  return false;
}

function isURL(url, options) {
  (0, _assertString2.default)(url);
  if (!url || url.length >= 2083 || /[\s<>]/.test(url)) {
    return false;
  }
  if (url.indexOf('mailto:') === 0) {
    return false;
  }
  options = (0, _merge2.default)(options, default_url_options);
  var protocol = void 0,
      auth = void 0,
      host = void 0,
      hostname = void 0,
      port = void 0,
      port_str = void 0,
      split$$1 = void 0,
      ipv6 = void 0;

  split$$1 = url.split('#');
  url = split$$1.shift();

  split$$1 = url.split('?');
  url = split$$1.shift();

  split$$1 = url.split('://');
  if (split$$1.length > 1) {
    protocol = split$$1.shift();
    if (options.require_valid_protocol && options.protocols.indexOf(protocol) === -1) {
      return false;
    }
  } else if (options.require_protocol) {
    return false;
  } else if (options.allow_protocol_relative_urls && url.substr(0, 2) === '//') {
    split$$1[0] = url.substr(2);
  }
  url = split$$1.join('://');

  if (url === '') {
    return false;
  }

  split$$1 = url.split('/');
  url = split$$1.shift();

  if (url === '' && !options.require_host) {
    return true;
  }

  split$$1 = url.split('@');
  if (split$$1.length > 1) {
    auth = split$$1.shift();
    if (auth.indexOf(':') >= 0 && auth.split(':').length > 2) {
      return false;
    }
  }
  hostname = split$$1.join('@');

  port_str = null;
  ipv6 = null;
  var ipv6_match = hostname.match(wrapped_ipv6);
  if (ipv6_match) {
    host = '';
    ipv6 = ipv6_match[1];
    port_str = ipv6_match[2] || null;
  } else {
    split$$1 = hostname.split(':');
    host = split$$1.shift();
    if (split$$1.length) {
      port_str = split$$1.join(':');
    }
  }

  if (port_str !== null) {
    port = parseInt(port_str, 10);
    if (!/^[0-9]+$/.test(port_str) || port <= 0 || port > 65535) {
      return false;
    }
  }

  if (!(0, _isIP2.default)(host) && !(0, _isFQDN2.default)(host, options) && (!ipv6 || !(0, _isIP2.default)(ipv6, 6))) {
    return false;
  }

  host = host || ipv6;

  if (options.host_whitelist && !checkHost(host, options.host_whitelist)) {
    return false;
  }
  if (options.host_blacklist && checkHost(host, options.host_blacklist)) {
    return false;
  }

  return true;
}
module.exports = exports['default'];
});

var isURL = unwrapExports(isURL_1);

var isUUID_1 = createCommonjsModule(function (module, exports) {
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = isUUID;



var _assertString2 = _interopRequireDefault(assertString_1);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var uuid = {
  3: /^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
  4: /^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
  5: /^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
  all: /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i
};

function isUUID(str) {
  var version = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'all';

  (0, _assertString2.default)(str);
  var pattern = uuid[version];
  return pattern && pattern.test(str);
}
module.exports = exports['default'];
});

var isUUID = unwrapExports(isUUID_1);

var asyncGenerator = function () {
  function AwaitValue(value) {
    this.value = value;
  }

  function AsyncGenerator(gen) {
    var front, back;

    function send(key, arg) {
      return new Promise(function (resolve, reject) {
        var request = {
          key: key,
          arg: arg,
          resolve: resolve,
          reject: reject,
          next: null
        };

        if (back) {
          back = back.next = request;
        } else {
          front = back = request;
          resume(key, arg);
        }
      });
    }

    function resume(key, arg) {
      try {
        var result = gen[key](arg);
        var value = result.value;

        if (value instanceof AwaitValue) {
          Promise.resolve(value.value).then(function (arg) {
            resume("next", arg);
          }, function (arg) {
            resume("throw", arg);
          });
        } else {
          settle(result.done ? "return" : "normal", result.value);
        }
      } catch (err) {
        settle("throw", err);
      }
    }

    function settle(type, value) {
      switch (type) {
        case "return":
          front.resolve({
            value: value,
            done: true
          });
          break;

        case "throw":
          front.reject(value);
          break;

        default:
          front.resolve({
            value: value,
            done: false
          });
          break;
      }

      front = front.next;

      if (front) {
        resume(front.key, front.arg);
      } else {
        back = null;
      }
    }

    this._invoke = send;

    if (typeof gen.return !== "function") {
      this.return = undefined;
    }
  }

  if (typeof Symbol === "function" && Symbol.asyncIterator) {
    AsyncGenerator.prototype[Symbol.asyncIterator] = function () {
      return this;
    };
  }

  AsyncGenerator.prototype.next = function (arg) {
    return this._invoke("next", arg);
  };

  AsyncGenerator.prototype.throw = function (arg) {
    return this._invoke("throw", arg);
  };

  AsyncGenerator.prototype.return = function (arg) {
    return this._invoke("return", arg);
  };

  return {
    wrap: function (fn) {
      return function () {
        return new AsyncGenerator(fn.apply(this, arguments));
      };
    },
    await: function (value) {
      return new AwaitValue(value);
    }
  };
}();





var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

// We want to set the messages a superglobal so that imports across files
// reference the same messages object.
var _global = typeof window !== 'undefined' ? window : global || {};

/**
 * Global validation message registry.
 */
var messages = _global.__vuemc_validation_messages = _global.__vuemc_validation_messages || new (function () {
    function _class() {
        classCallCheck(this, _class);

        this.reset();
    }

    /**
     * Resets everything to the default configuration.
     */


    createClass(_class, [{
        key: 'reset',
        value: function reset() {
            this.$locale = 'en-us';
            this.$fallback = 'en-us';
            this.$locales = {};

            this.register(en_us);
        }

        /**
         * Sets the active locale.
         *
         * @param {string} locale
         */

    }, {
        key: 'locale',
        value: function locale(_locale) {
            this.$locale = _.toLower(_locale);
        }

        /**
         * Registers a language pack.
         */

    }, {
        key: 'register',
        value: function register(bundle) {
            var _this = this;

            var locale = _.toLower(bundle.locale);

            _.each(_.get(bundle, 'messages', {}), function (message, name) {
                _.set(_this.$locales, [locale, name], _.template(message));
            });
        }

        /**
         * Replaces or adds a new message for a given name and optional locale.
         *
         * @param {string} name
         * @param {string} format
         */

    }, {
        key: 'set',
        value: function set$$1(name, format, locale) {
            var template$$1 = _.isString(format) ? _.template(format) : format;

            // Use the given locale.
            if (locale) {
                _.set(this.$locales, [locale, name], template$$1);

                // Otherwise use the active locale.
            } else if (this.$locale) {
                _.set(this.$locales, [this.$locale, name], template$$1);

                // Otherwise fall back to the default locale.
            } else {
                _.set(this.$locales, [this.$fallback, name], template$$1);
            }
        }

        /**
         * Returns a formatted string for a given message name and context data.
         *
         * @param {string} name
         * @param {Object} data
         *
         * @returns {string} The formatted message.
         */

    }, {
        key: 'get',
        value: function get$$1(name) {
            var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};


            // Attempt to find the name using the active locale, falling back to the
            // active locale's language, and finally falling back to the default.
            var template$$1 = _.get(this.$locales, [this.$locale, name], _.get(this.$locales, [_.split(this.$locale, '-')[0], name], _.get(this.$locales, [this.$fallback, name])));

            // Fall back to a blank string so that we don't potentially
            // leak message names or context data into the template.
            if (!template$$1) {
                return '';
            }

            return template$$1(data);
        }
    }]);
    return _class;
}())();

var rule = function rule(config) {
    var name = _.get(config, 'name');
    var data = _.get(config, 'data', {});
    var test = _.get(config, 'test', _.stubTrue);

    /**
     * This is the function that is called when using this rule.
     * It has some extra metadata to allow rule chaining and custom formats.
     */
    var $rule = function $rule(value, attribute, model) {

        // `true` if this rule's core acceptance criteria was met.
        var valid = test(value, attribute, model);

        // If valid, check that all rules in the "and" chain also pass.
        if (valid) {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = $rule._and[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var _and = _step.value;

                    var result = _and(value, attribute, model);

                    // If any of the chained rules return a string, we know that
                    // that rule has failed, and therefore this chain is invalid.
                    if (_.isString(result)) {
                        return result;
                    }

                    // If the function simply returned `false`, we need to fall back
                    // to the parent rule's error message, so we indicate that the
                    // rule didn't pass validation, and break out of the chain.
                    if (result === false) {
                        valid = false;
                        break;
                    }
                }

                // Either there weren't any "and" rules or they all passed.
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            if (valid) {
                return true;
            }

            // This rule's acceptance criteria was not met, but there is a chance
            // that a rule in the "or" chain's might pass.
        } else {
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = $rule._or[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var _or = _step2.value;

                    var _result = _or(value, attribute, model);

                    // A rule should either return true in the event of a general
                    // "pass", or nothing at all. A failure would have to be a
                    // string message (usually from another rule) or `false`.
                    if (_result === true || _.isUndefined(_result)) {
                        return true;
                    }
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }

        // At this point we want to report that this rule has failed, because
        // none of the "and" or "or" chains passed either.

        // Add the invalid value to the message context, which is made available
        // to all rules by default. This allows for ${value} interpolation.
        _.assign(data, { attribute: attribute, value: value });

        // This would be a custom format explicitly set on this rule.
        var format = _.get($rule, '_format');

        // Use the default message if an explicit format isn't set.
        if (!format) {
            return messages.get(name, data);
        }

        // Replace the custom format with a template if it's still a string.
        if (_.isString(format)) {
            $rule._format = format = _.template(format);
        }

        return format(data);
    };

    /**
     * @returns {Function} A copy of this rule, so that appending to a chain or
     *                     setting a custom format doesn't modify the base rule.
     */
    $rule.copy = function () {
        return _.assign(rule({ name: name, test: test, data: data }), _.pick($rule, ['_format', '_and', '_or']));
    };

    /**
     * Sets a custom error message format on this rule.
     *
     * @param {string|Function} format
     */
    $rule.format = function (format) {
        return _.assign($rule.copy(), { _format: format });
    };

    /**
     * Adds another rule or function to this rule's OR chain. If the given rule
     * passes when this one fails, this rule will return `true`.
     *
     * @param {Function|Function[]} rules One or more functions to add to the chain.
     */
    $rule.or = function (rules) {
        return _.assign($rule.copy(), { _or: _.concat($rule._or, rules) });
    };

    /**
     * Adds another rule or function to this rule's AND chain. If the given rule
     * fails when this one passes, this rule will return `false`.
     *
     * @param {Function|Function[]} rules One or more functions to add to the chain.
     */
    $rule.and = function (rules) {
        return _.assign($rule.copy(), { _and: _.concat($rule._and, rules) });
    };

    $rule._and = []; // "and" chain
    $rule._or = []; // "or" chain
    $rule._format = null; // Custom format

    return $rule;
};

/**
 * AVAILABLE RULES
 */

/**
 * Checks if the value is after a given date string or `moment` object.
 */
var after = function after(date) {
    return rule({
        name: 'after',
        data: { date: date },
        test: function test(value) {
            return moment(value).isAfter(date);
        }
    });
};

/**
 * Checks if a value only has letters.
 */
var alpha = rule({
    name: 'alpha',
    test: function test(value) {
        return _.isString(value) && isAlpha(_.deburr(value));
    }
});

/**
 * Checks if a value only has letters or numbers.
 */
var alphanumeric = rule({
    name: 'alphanumeric',
    test: function test(value) {
        return _.isString(value) && isAlphanumeric(_.deburr(value));
    }
});

/**
 * Checks if a value is an array.
 */
var array = rule({
    name: 'array',
    test: _.isArray
});

/**
 * Checks if a value is a string consisting only of ASCII characters.
 */
var ascii = rule({
    name: 'ascii',
    test: function test(value) {
        return _.isString(value) && /^[\x00-\x7F]+$/.test(value);
    }
});

/**
 * Checks if a value is a valid Base64 string.
 */
var base64 = rule({
    name: 'base64',
    test: function test(value) {
        return _.isString(value) && isBase64(value);
    }
});

/**
 * Checks if a value is before a given date string or `moment` object.
 */
var before = function before(date) {
    return rule({
        name: 'before',
        data: { date: date },
        test: function test(value) {
            return moment(value).isBefore(date);
        }
    });
};

/**
 * Checks if a value is between a given minimum or maximum, inclusive by default.
 */
var between = function between(min, max) {
    var inclusive = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    var _min = +(_.isString(min) ? moment(min) : min);
    var _max = +(_.isString(max) ? moment(max) : max);

    return rule({
        data: { min: min, max: max },
        name: inclusive ? 'between_inclusive' : 'between',
        test: function test(value) {
            var _value = +(_.isString(value) ? moment(value) : value);

            return inclusive ? _.gte(_value, _min) && _.lte(_value, _max) : _.gt(_value, _min) && _.lt(_value, _max);
        }
    });
};

/**
 * Checks if a value is a boolean (strictly true or false).
 */
var boolean = rule({
    name: 'boolean',
    test: _.isBoolean
});

/**
 * Checks if a value is a valid credit card number.
 */
var creditcard = rule({
    name: 'creditcard',
    test: function test(value) {
        return _.isString(value) && isCreditCard(value);
    }
});

/**
 * Checks if a value is parseable as a date.
 */
var date = rule({
    name: 'date',
    test: function test(value) {
        return moment(value).isValid();
    }
});

/**
 * Checks if a value matches the given date format.
 *
 * @see https://momentjs.com/docs/#/displaying/format
 */
var dateformat = function dateformat(format) {
    return rule({
        name: 'dateformat',
        data: { format: format },
        test: function test(value) {
            return moment(value, format, true).isValid();
        }
    });
};

/**
 * Checks if a value is not `undefined`
 */
var defined = rule({
    name: 'defined',
    test: function test(value) {
        return !_.isUndefined(value);
    }
});

/**
 * Checks if a value is a valid email address.
 */
var email = rule({
    name: 'email',
    test: function test(value) {
        return _.isString(value) && isEmail(value);
    }
});

/**
 * Checks if value is considered empty.
 *
 * @see https://lodash.com/docs/#isEmpty
 */
var empty = rule({
    name: 'empty',
    test: _.isEmpty
});

/**
 * Alias for `equals`
 */
var equal = function equal(other) {
    return equals(other);
};

/**
 * Checks if a value equals the given value.
 */
var equals = function equals(other) {
    return rule({
        name: 'equals',
        data: { other: other },
        test: function test(value) {
            return _.isEqual(value, other);
        }
    });
};

/**
 * Checks if a value is greater than a given minimum.
 */
var gt$1 = function gt$$1(min) {
    return rule({
        name: 'gt',
        data: { min: min },
        test: function test(value) {
            return _.gt(value, min);
        }
    });
};

/**
 * Checks if a value is greater than or equal to a given minimum.
 */
var gte$1 = function gte$$1(min) {
    return rule({
        name: 'gte',
        data: { min: min },
        test: function test(value) {
            return _.gte(value, min);
        }
    });
};

/**
 * Checks if a value is an integer.
 */
var integer = rule({
    name: 'integer',
    test: _.isInteger
});

/**
 * Checks if a value is a valid IP address.
 */
var ip = rule({
    name: 'ip',
    test: function test(value) {
        return _.isString(value) && isIP(value);
    }
});

/**
 * Checks if a value is a zero-length string.
 */
var isblank = rule({
    name: 'isblank',
    test: function test(value) {
        return value === '';
    }
});

/**
 * Checks if a value is `null` or `undefined`.
 */
var isnil = rule({
    name: 'isnil',
    test: _.isNil
});

/**
 * Checks if a value is `null`.
 */
var isnull = rule({
    name: 'isnull',
    test: _.isNull
});

/**
 * Checks if a value is a valid ISO8601 date string.
 */
var iso8601 = rule({
    name: 'iso8601',
    test: function test(value) {
        return _.isString(value) && isISO8601(value);
    }
});

/**
 * Checks if a value is valid JSON.
 */
var json = rule({
    name: 'json',
    test: function test(value) {
        return _.isString(value) && isJSON(value);
    }
});

/**
 * Checks if a value's length is at least a given minimum, and no more than an
 * optional maximum.
 *
 * @see https://lodash.com/docs/#toLength
 */
var length = function length(min, max) {

    // No maximum means the value must be *at least* the minimum.
    if (_.isUndefined(max)) {
        return rule({
            name: 'length',
            data: { min: min, max: max },
            test: function test(value) {
                return _.size(value) >= min;
            }
        });
    }

    // Minimum and maximum given, so check that the value is within the range.
    return rule({
        name: 'length_between',
        data: { min: min, max: max },
        test: function test(value) {
            var length = _.size(value);
            return length >= min && length <= max;
        }
    });
};

/**
 * Checks if a value is less than a given maximum.
 */
var lt$1 = function lt$$1(max) {
    return rule({
        name: 'lt',
        data: { max: max },
        test: function test(value) {
            return _.lt(value, max);
        }
    });
};

/**
 * Checks if a value is less than or equal to a given maximum.
 */
var lte$1 = function lte$$1(max) {
    return rule({
        name: 'lte',
        data: { max: max },
        test: function test(value) {
            return _.lte(value, max);
        }
    });
};

/**
 * Checks if a value matches a given regular expression string or RegExp.
 */
var match = function match(pattern) {
    return rule({
        name: 'match',
        data: { pattern: pattern },
        test: function test(value) {
            return new RegExp(pattern).test(value);
        }
    });
};

/**
 * Alias for `lte`.
 */
var max = function max(_max2) {
    return lte$1(_max2);
};

/**
 * Alias for `gte`.
 */
var min = function min(_min2) {
    return gte$1(_min2);
};

/**
 * Checks if a value is negative.
 */
var negative = rule({
    name: 'negative',
    test: function test(value) {
        return _.toNumber(value) < 0;
    }
});

/**
 *
 */
var not = function not() {
    for (var _len = arguments.length, values = Array(_len), _key = 0; _key < _len; _key++) {
        values[_key] = arguments[_key];
    }

    return rule({
        name: 'not',
        test: function test(value) {
            return !_.includes(values, value);
        }
    });
};

/**
 * Checks if a value is a number (integer or float), excluding `NaN`.
 */
var number = rule({
    name: 'number',
    test: function test(value) {
        return _.isFinite(value);
    }
});

/**
 * Checks if a value is a number or numeric string, excluding `NaN`.
 */
var numeric = rule({
    name: 'numeric',
    test: function test(value) {
        return _.isNumber(value) && !_.isNaN(value) || value && _.isString(value) && !_.isNaN(_.toNumber(value));
    }
});

/**
 * Checks if a value is an object, excluding arrays and functions.
 */
var object = rule({
    name: 'object',
    test: function test(value) {
        return _.isObject(value) && !_.isArray(value) && !_.isFunction(value);
    }
});

/**
 * Checks if a value is positive.
 */
var positive = rule({
    name: 'positive',
    test: function test(value) {
        return _.toNumber(value) > 0;
    }
});

/**
 * Checks if a value is present, ie. not `null`, `undefined`, or a blank string.
 */
var required = rule({
    name: 'required',
    test: function test(value) {
        return !(_.isNil(value) || value === '');
    }
});

/**
 * Checks if a value equals another attribute's value.
 */
var same = function same(other) {
    return rule({
        name: 'same',
        data: { other: other },
        test: function test(value, attribute, model) {
            return _.isEqual(value, model.get(other));
        }
    });
};

/**
 * Checks if a value is a string.
 */
var string = rule({
    name: 'string',
    test: _.isString
});

/**
 * Checks if a value is a valid URL string.
 */
var url = rule({
    name: 'url',
    test: function test(value) {
        return _.isString(value) && isURL(value);
    }
});

/**
 * Checks if a value is a valid UUID.
 */
var uuid = rule({
    name: 'uuid',
    test: function test(value) {
        return _.isString(value) && isUUID(value);
    }
});

exports.messages = messages;
exports.rule = rule;
exports.after = after;
exports.alpha = alpha;
exports.alphanumeric = alphanumeric;
exports.array = array;
exports.ascii = ascii;
exports.base64 = base64;
exports.before = before;
exports.between = between;
exports.boolean = boolean;
exports.creditcard = creditcard;
exports.date = date;
exports.dateformat = dateformat;
exports.defined = defined;
exports.email = email;
exports.empty = empty;
exports.equal = equal;
exports.equals = equals;
exports.gt = gt$1;
exports.gte = gte$1;
exports.integer = integer;
exports.ip = ip;
exports.isblank = isblank;
exports.isnil = isnil;
exports.isnull = isnull;
exports.iso8601 = iso8601;
exports.json = json;
exports.length = length;
exports.lt = lt$1;
exports.lte = lte$1;
exports.match = match;
exports.max = max;
exports.min = min;
exports.negative = negative;
exports.not = not;
exports.number = number;
exports.numeric = numeric;
exports.object = object;
exports.positive = positive;
exports.required = required;
exports.same = same;
exports.string = string;
exports.url = url;
exports.uuid = uuid;
